﻿using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using Wisej.Web;

namespace gridbug
{
	public partial class Window1 : Form
	{
		private static readonly Item[] items = {new Item("a"), new Item("b"), new Item("c"), new Item("d"), new Item("e")};

		public Window1()
		{
			this.InitializeComponent();
			this.dataGridView1.DataSource = new List<Item>(items);
		}

		private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
		{
			// Backup selected items:
			List<object> selectedItems = this.dataGridView1.SelectedRows.Select(row => row.DataBoundItem).ToList();

			// Re-bind items.
			this.dataGridView1.DataSource = new List<Item>(items);

			// Restore selection.
			foreach (DataGridViewRow row in this.dataGridView1.Rows)
			{
				if (selectedItems.Contains(row.DataBoundItem))
				{
					row.Selected = true;
					Debug.WriteLine($"{row.DataBoundItem} selected.");
				}
				else
				{
					row.Selected = false;
				}
			}
		}
	}

	/// <summary>
	/// Test item class.
	/// </summary>
	public sealed class Item
	{
		public string Name { get; set; }

		public Item(string name)
		{
			this.Name = name;
		}

		public override string ToString()
		{
			return this.Name;
		}
	}
}
